"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CancerDemographics(ProtocolElement):
    """
    This defines a Cancer Demographics
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "center",
        "consentStatus",
        "gelId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "consentStatus": reports_3_0_0.ConsentStatus,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "sex": reports_3_0_0.Sex,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "org.gel.models.report.avro.ConsentStatus": reports_3_0_0.ConsentStatus,
            "org.gel.models.report.avro.Sex": reports_3_0_0.Sex,
            "org.gel.models.report.avro.CancerDemographics": reports_3_0_0.CancerDemographics,
        }

    __slots__ = [
        "center",
        "consentStatus",
        "gelId",
        "additionalInformation",
        "assignedICD10",
        "centerPatientId",
        "labkeyParticipantId",
        "primaryDiagnosis",
        "sampleId",
        "sex",
    ]

    def __init__(
        self,
        center,
        consentStatus,
        gelId,
        additionalInformation=None,
        assignedICD10=None,
        centerPatientId=None,
        labkeyParticipantId=None,
        primaryDiagnosis=None,
        sampleId=None,
        sex=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_3_0_0.CancerDemographics model.

        :param center:
            Center
        :type center: str
        :param consentStatus:
            What has this participant consented to?     A participant that has
            been consented to the programme should also have sequence
            data associated with them; however     this needs to be
            programmatically checked
        :type consentStatus: ConsentStatus
        :param gelId:
            Individual Id (this is the individual id (gel ID))
        :type gelId: str
        :param additionalInformation:
            We could add a map here to store additional information for example
            URIs to images, ECGs, etc
        :type additionalInformation: None | dict[str, str]
        :param assignedICD10:
            assigned ICD10 code
        :type assignedICD10: None | str
        :param centerPatientId:
            Center patient ID
        :type centerPatientId: None | str
        :param labkeyParticipantId:
            Labkey ID - this field together with the study should be a unique id
            to find the labkey data
        :type labkeyParticipantId: None | str
        :param primaryDiagnosis:
            This should be an enumeration when it is well defined     blood,
            breast, prostate, colorectal, cll, aml, renal, ovarian,
            skin, lymphNode, bone, saliva //for individual - there
            could be more than I have listed here, in fact there
            definitely will.
        :type primaryDiagnosis: None | str
        :param sampleId:
            Sample Id (e.g, LP00012645_5GH))
        :type sampleId: None | list[str]
        :param sex:
            Sex
        :type sex: None | Sex
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
